<?php 

$target_dir="TC";
$pname="ATS";

//read compiled filelist
$complist=array();
if($handle = opendir($target_dir."/bin")) {
 while (false !== ($fname = readdir($handle))) {
  if ( substr($fname,0,1) != "." ) { 
   $fname=substr($fname,0,strpos($fname,"."));
   $complist[]=$fname;
  }
 }
 closedir($handle);
}

$error_list=array(); //list of wrong compilation results

//check compilation results
$pfile=file($target_dir."/".$pname.".tcproj");

for($i=0;$i<sizeof($pfile);$i++) {

  $pfile[$i]=chop($pfile[$i]);
  $pfile[$i]=substr($pfile[$i],strpos($pfile[$i],"<"));

  if(substr($pfile[$i],0,6)=='<name>') {
   $endtag=strpos($pfile[$i],"</");
   $out_name=substr($pfile[$i],6,$endtag-6);
   $compiled=FALSE;
   for($j=0;$j<sizeof($complist);$j++) {
   	   if($complist[$j]==$out_name) {
   	     $compiled=TRUE;
   	    // echo "|comp: $out_name |";
   	   }
   }
   //if($compiled==FALSE) echo "|nc: $out_name |";
   
   $nline=chop($pfile[$i+1]);
   $nline=substr($nline,strpos($nline,"<"));
   $endtag=strpos($nline,"</");
   $in_name=substr($nline,6,$endtag-6);
   
   //check if the file should compile
   $content=file($target_dir."/".$in_name);
   $c_result="unknown";
   for($j=0;$j<sizeof($content);$j++) {
     if(strpos($content[$j],"@verdict")!=FALSE) {
       if(strpos($content[$j],"accept")!=FALSE) $c_result="accept";
       if(strpos($content[$j],"reject")!=FALSE) $c_result="reject";
     }
     if(strpos($in_name,"_import")!==FALSE) $c_result="import";
   }
   
   if( ($c_result=="accept")&&($compiled==FALSE) ) $error_list[]=$in_name;
   if( ($c_result=="reject")&&($compiled==TRUE) ) $error_list[]=$in_name;
   if( $c_result=="unknown") $error_list[]=$in_name;

   if( (substr($in_name,-4,4)=="ttcn")&&(substr($in_name,0,3)!="Sem")&&(substr($in_name,0,3)!="Syn")&&(substr($in_name,0,6)!="NegSem")&&(substr($in_name,0,6)!="NegSyn") ) echo "\nfile name in wrong format: $in_name ";   
  }
}

$logfile=fopen("Unexpected_compilation_results.txt","w");
echo "\n Listing of unexpected compilation results:";
for($i=0;$i<sizeof($error_list);$i++) {
  echo "\n ".$error_list[$i];
  fputs($logfile,"\n".$error_list[$i]);
}
fclose($logfile);

?>