<?php 

$ATS_dir="ATS";
$target_dir="TC";
$semantic_dir="TC_SEM";
$pname="ATS";

//copy TTCN files
$filelist=array();
$filelist=copy_ttcn_files($ATS_dir,$target_dir,$filelist);

//build project file
$pf_scripts="";
for($i=0;$i<sizeof($filelist);$i++) {
  $pf_scripts.='
  <script>
    <name>'.substr($filelist[$i],0,strlen($filelist[$i]-5)).'</name>
    <file>'.$filelist[$i].'</file>
    <type>ttcn3</type>
   </script>
';
}

$pf_text1='﻿<?xml version="1.0" encoding="utf-8"?>
<solution>
 <scripts>
  <items>
';

$pf_text2='  </items>
 </scripts>
 <verstool />
 <sut />
 <codec_rules>CodecRules_'.$pname.'.txt</codec_rules>
 <ExternalAttributeFiles>
  <items />
 </ExternalAttributeFiles>
 <ModuleParFiles>
  <items />
 </ModuleParFiles>
 <TestcaseSelections>
  <items />
 </TestcaseSelections>
 <TestCampaigns>
  <items />
 </TestCampaigns>
 <ttcn3_settings>
  <tc_block />
  <ttcn3_version>Ttcn3_2011</ttcn3_version>
  <asn>BER</asn>
  <dll_timeout>10</dll_timeout>
  <port>7777</port>
  <ctime>60</ctime>
  <sa_count>1</sa_count>
  <rtime>20</rtime>
  <codec_type>internal</codec_type>
  <enc>
   <plain>
    <byte_order>le</byte_order>
    <signed />
    <int>dword</int>
    <float>double</float>
    <custom_int>8</custom_int>
    <string>null</string>
    <custom_str>32</custom_str>
    <char>U16</char>
    <bool>dword</bool>
    <bin>dword</bin>
    <custom_bin>16</custom_bin>
    <align>1</align>
    <coll>word</coll>
    <str_unit>bytes</str_unit>
    <pad />
    <str_end>\r\n</str_end>
    <uni_end>\r\n</uni_end>
    <any>none</any>
   </plain>
  </enc>
  <no_bs_dq />
 </ttcn3_settings>
</solution>
';

$pfile=fopen($target_dir."/".$pname.".tcproj","w");
fputs($pfile,$pf_text1.$pf_scripts.$pf_text2);
fclose($pfile);
$pfile=fopen($target_dir."/CodecRules_".$pname.".txt","w");
fclose($pfile);

//copy TTCN semantic files
$filelist=array();
$filelist=copy_ttcn_sem_files($ATS_dir,$semantic_dir,$filelist);

//build project file
$pf_scripts="";
for($i=0;$i<sizeof($filelist);$i++) {
  $pf_scripts.='
  <script>
    <name>'.substr($filelist[$i],0,strlen($filelist[$i]-5)).'</name>
    <file>'.$filelist[$i].'</file>
    <type>ttcn3</type>
   </script>
';
}

$pfile=fopen($semantic_dir."/".$pname.".tcproj","w");
fputs($pfile,$pf_text1.$pf_scripts.$pf_text2);
fclose($pfile);
$pfile=fopen($semantic_dir."/CodecRules_".$pname.".txt","w");
fclose($pfile);


function copy_ttcn_files($in_dir,$out_dir,$f_array) {
	
if($handle = opendir($in_dir)) {
 while (false !== ($fname = readdir($handle))) {
  if ( substr($fname,0,1) != "." ) { 
   if(substr($fname,-5,5)=='.ttcn') {
    $content=file($in_dir."/".$fname);
    $modcount=0;
    for($j=0;$j<sizeof($content);$j++) {
     if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE)) $modcount++;
    }

     if($modcount<=1) copy($in_dir."/".$fname,$out_dir."/".$fname);
     if($modcount>1) {
      $wfile=fopen($out_dir."/".$fname,"w");
      $modcount=0;
      for($j=0;$j<sizeof($content);$j++) {
        if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE)) $modcount++;
        if($modcount>1) break;
        else fputs($wfile,$content[$j]);
      }
      fclose($wfile);
      while($j<sizeof($content)) {
      	$mpos=strpos($content[$j],"module")+7; //point to name
      	while( ((substr($content[$j],$mpos,1)==" ")||(substr($content[$j],$mpos,1)=="\t"))&&($mpos<strlen($content[$j])) ) $mpos++;
      	$epos=$mpos+1;
      	while( ((substr($content[$j],$epos,1)!=" ")&&(substr($content[$j],$epos,1)!="\t"))&&($epos<strlen($content[$j])) ) $epos++;
      	$modname=substr($content[$j],$mpos,$epos-$mpos);
      	$xfile=fopen($out_dir."/".$modname.".ttcn","w");
      	fputs($xfile,$content[$j]); $j++;
      	while($j<sizeof($content)) {
      	  if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE) ) break;
      	  else {
      	    fputs($xfile,$content[$j]); $j++;
      	  }
      	}
      	fclose($xfile);
      	$f_array[]=$modname.".ttcn";
      }
      
     }
     //echo "\n content: $fname";
     $f_array[]=$fname;
   }
   if(is_dir($in_dir.'/'.$fname)) {
     $f_array=copy_ttcn_files($in_dir."/".$fname,$out_dir,$f_array);
   }
  }
 }
 closedir($handle);
} else {
	echo "\n no such directory: $in_dir\n";
}
	
 return $f_array;
}


function copy_ttcn_sem_files($in_dir,$out_dir,$f_array) {
	
if($handle = opendir($in_dir)) {
 while (false !== ($fname = readdir($handle))) {
  if ( substr($fname,0,1) != "." ) { 
   if( substr($fname,-5,5)=='.ttcn' ) {
    $content=file($in_dir."/".$fname);
    $c_result="unknown";
    $modcount=0;
    for($j=0;$j<sizeof($content);$j++) {
     if(strpos($content[$j],"@verdict")!=FALSE) {
       if(strpos($content[$j],"accept")!=FALSE) $c_result="accept";
       if(strpos($content[$j],"reject")!=FALSE) $c_result="reject";
     }
     if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE)) $modcount++;
    }

    if($c_result=="accept") {
     if($modcount<=1) copy($in_dir."/".$fname,$out_dir."/".$fname);
     if($modcount>1) {
      $wfile=fopen($out_dir."/".$fname,"w");
      $modcount=0;
      for($j=0;$j<sizeof($content);$j++) {
        if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE)) $modcount++;
        if($modcount>1) break;
        else fputs($wfile,$content[$j]);
      }
      fclose($wfile);
      while($j<sizeof($content)) {
      	$mpos=strpos($content[$j],"module")+7; //point to name
      	while( ((substr($content[$j],$mpos,1)==" ")||(substr($content[$j],$mpos,1)=="\t"))&&($mpos<strlen($content[$j])) ) $mpos++;
      	$epos=$mpos+1;
      	while( ((substr($content[$j],$epos,1)!=" ") && (substr($content[$j],$epos,1)!="\t"))&&($epos<strlen($content[$j])) ) $epos++;
      	$modname=substr($content[$j],$mpos,$epos-$mpos);
      	$xfile=fopen($out_dir."/".$modname.".ttcn","w");
      	fputs($xfile,$content[$j]); $j++;
      	while($j<sizeof($content)) {
      	  if( ((substr(trim($content[$j]),0,7)=="module ")||(substr(trim($content[$j]),0,7)=="module\t"))&&(strpos($content[$j],"{")!==FALSE)) break;
      	  else {
      	    fputs($xfile,$content[$j]); $j++;
      	  }
      	}
      	fclose($xfile);
      	$f_array[]=$modname.".ttcn";
      }
      
     }
     //echo "\n content: $fname";
     $f_array[]=$fname;
    }
   }
   if(is_dir($in_dir.'/'.$fname)) {
     $f_array=copy_ttcn_sem_files($in_dir."/".$fname,$out_dir,$f_array);
   }
  }
 }
 closedir($handle);
} else {
	echo "\n no such directory: $in_dir\n";
}
	
 return $f_array;
}

?>